// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "State.h"
#include "StateManager.h"

// Creation/destruction
State::State() {}
State::~State() {}

// State functions
void State::initialize() {}
void State::cleanup() {}
void State::pause() {}
void State::resume() {}
void State::frameStarted(Real dt) {}
void State::frameEnded(Real dt) {}

// State management
void State::changeState(State* state)
{
	StateManager::getSingleton().changeState(state);
}

// Key events
void State::keyClicked(KeyEvent *e) {}
void State::keyPressed(KeyEvent *e) {}
void State::keyReleased(KeyEvent *e) {}
void State::keyRepeated(int kc) {}

bool State::isKeyDown(KeyCode kc) const
{
	InputReader* inputReader = StateManager::getSingleton().mEventProcessor->getInputReader();
	return inputReader->isKeyDown(kc);
}

// Mouse events
void State::mouseMoved(MouseEvent *e) {}
void State::mouseDragged(MouseEvent *e) {}
void State::mousePressed(MouseEvent *e) {}
void State::mouseReleased(MouseEvent *e) {}
